#include <dbox.h>
#include <config.h>
#include <libdboxversion.h>
#include <parseoptions.h>
#include <dboxversion.h>

#undef DEBUG
#include "radius.h"

#include "dboxradius.h"

class parseoptionst:public parseoptions_baset
 {
 public:
  virtual int doit();
  virtual void help();
  parseoptionst():parseoptions_baset("c:(auth)u:(ppp)") { }
 };

extern "C" int dict_init();

extern "C" int dboxuser(struct userinfot *userinfo,
                        char **rejecterror, char *pm,
                        int do_debug);

extern "C" int userparse(char *buffer, VALUE_PAIR **first_pair);

extern char *radius_dir;

int parseoptionst::doit()
 {
  char pm[TEXTLEN]="", user[TEXTLEN]="";
  char buffer[TEXTLEN*2];

  radius_dir = RADIUS_DIR;

  if(dict_init())
   {
    cerr << "Failed to initialize directory\n";
    return 1;
   }

  if(cmdline.isset('c'))
    strmaxcpy(pm, cmdline.getval('c'), TEXTLEN-1);

  if(cmdline.isset('u'))
    strmaxcpy(user, cmdline.getval('u'), TEXTLEN-1);

  userinfot userinfo;
  VALUE_PAIR *pair=(VALUE_PAIR *)NULL;
  strmaxcpy(userinfo.username, user, TEXTLEN-1);

  if(cmdline.isset("ppp"))
   {
    snprintf(buffer, TEXTLEN*2, "Framed-Protocol=PPP\n");
    userparse(buffer, &pair);
   }

  userinfo.pair=pair;

  if(cmdline.isset("auth"))
   {
    char *error;
    int result;

    result=dboxuser(&userinfo, &error, pm, TRUE);

    cout << "RESULT: " << result << "\n";
    cout << "ERROR: " << error << "\n";
    cout << "Framed-Protocol: " << userinfo.framed_protocol << "\n";
    cout << "Password: " << userinfo.password << "\n";
    cout << "Message: " << userinfo.message << "\n";
    cout << "Service-Type: " << userinfo.service_type << "\n";
    cout << "Framed-Compression: " << userinfo.framed_compression << "\n";
    cout << "Login-Service: " << userinfo.login_service << "\n";
    cout << "Session-Timeout: " << userinfo.session_timeout << "\n";
   }
  else
    help();

  return 0;
 }

void parseoptionst::help()
 {
  cout <<
    "\n"
    "* * DBOXRADIUS TEST MODULE - Version " DBOXVERSIONNR " * *\n"
    "\n"
    "Usage:                       Purpose:\n"
    "\n"
    "\n"
    "Additonal options:\n"
    "\n";
 }

int main(int argc, char **argv)
 {
  if(init_libdbox(LIBDBOXVERSION, LIBDBOXVERSIONNR) || config.read(""))
    return 1;

  parseoptionst parseoptions;

  return parseoptions.parseoptions(argc, argv);
 }

