/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: verify username/password for SMTP

*/

#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <dirent.h>

#include <tools.h>
#include <dboxpath.h>
#include <portinfo.h>
#include <logf.h>
#include "ostatus.h"
#include "../online/userlog.h"
#include "http.h"
#include "smtplogin.h"

bool do_auth(const char *login, const char *pass)
 {
  if(strchr(login, '/')!=NULL)
    return TRUE;

  strmaxcpy(status.username, login, TEXTLEN-1);

  status.userprofile.setname(login);

  if(status.userprofile.name[0]==0)
   {
    logf.printf("smtplogin", "no username");
    return TRUE;
   }

  if(status.userprofile.read())
   {
    logf.printf("smtplogin", "%s: not found", status.userprofile.name);
    return TRUE;
   }

  snprintf(status.userlogfile, DIRLEN, "%slogfile",
    status.userprofile.getpath());

  if(verifylogin(&status.userprofile, pass))
   {
    userlogprintf1(status, "smtplogin", "wrong password");
    return TRUE;
   }

  userlogprintf1(status, "smtplogin", "successfull login");

  return FALSE;
 }

void smtplogin(httpt &http)
 {
  const char *l_ptr=http.get_header("Login");
  const char *p_ptr=http.get_header("Password");

  if(l_ptr==NULL || p_ptr==NULL) return;

  if(do_auth(l_ptr, p_ptr))
    cout << "0\r\n";
  else
    cout << "100\r\n";
 }
